#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_fs_1 = require("node:fs");
const index_1 = __importDefault(require("./index"));
function main() {
    return __awaiter(this, void 0, void 0, function* () {
        const file = `./runescape-text-${Date.now()}.gif`;
        if ((0, node_fs_1.existsSync)(file)) {
            console.log(`${file} already exists. Exiting...`);
            process.exit(1);
        }
        const [, , ...args] = process.argv;
        const string = args.join(" ");
        const options = { debug: true };
        const wordWrapOptions = {};
        const { data } = (0, index_1.default)(string, options, wordWrapOptions);
        (0, node_fs_1.writeFileSync)(file, data);
        console.log(`\nFile written to: ${file}`);
    });
}
main();
