"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWordWrapConfig = exports.getConfig = void 0;
const defaultOptions_1 = require("../defaultOptions");
const defaultWordWrapOptions_1 = require("../defaultWordWrapOptions");
function getConfig(options = {}) {
    const mergedOptions = Object.assign(Object.assign({}, defaultOptions_1.defaultOptions), options);
    const delayPerFrame = 1000 / mergedOptions.fps;
    const totalFrames = Math.round(mergedOptions.duration / delayPerFrame);
    return Object.assign(Object.assign({}, mergedOptions), { delayPerFrame, totalFrames });
}
exports.getConfig = getConfig;
function getWordWrapConfig(wordWrapOptions = {}) {
    return Object.assign(Object.assign({}, defaultWordWrapOptions_1.defaultWordWrapOptions), wordWrapOptions);
}
exports.getWordWrapConfig = getWordWrapConfig;
